#!/bin/bash
# vim  :set tabstop=4
# NeoKylin Military Server 5.0
###########################################
#        post-install-for-mips64el        #
###########################################
chroot /mnt/sysimage << EOF
cd /boot
grub2-mkconfig -o efi/EFI/BOOT/grub.cfg

EOF

if [ -f /tmp/.overlay ];then
        OVERLAY_DEV=$(df -h|grep mnt/sysimage/overlay|sed -n 1p|awk '{print $1}')
        if [ -n "$OVERLAY_DEV" ];then
                OVERLAY=1
                OVER_UUID=$(blkid -s UUID $OVERLAY_DEV|awk -F "\"" '{print $2}')
                OVERLAY_UUID="UUID=$OVER_UUID"
	fi
else
  OVERLAY=0
fi
OVERLAY_DEV="$OVERLAY_UUID"	
###########################################
ARCH=$(uname -m|cut -b 1-4)
if [ "$ARCH" = "mips" ]; then
	#initialize variable
	ROOT_DIR="/mnt/sysimage"
	ROOT_DEV=`df |grep /mnt/sysimage$ | awk -F " " '{print $1}'`   #  
	ROOT_UUID=`blkid $ROOT_DEV | cut -d " " -f 2`
	BACKUP_DEV=`df |grep /mnt/sysimage/srv$ | awk -F " " '{print $1}'`   #  
	BACK_CMDLINE="tty rhgb quiet rescue"
	overlay_title="(with Power Down Protection)"
	#KERNEL_CMDLINE="rhgb quiet"
	#CDROM="/run/install/repo"
	df |grep "/run/install/repo$" > /dev/null
	if [ $? -eq 0 ];then
		CDROM="/run/install/repo"
	else
		CDROM="/run/initramfs/live"
	fi
	#######################################################LVM
	echo $ROOT_DEV |grep "/dev/mapper/"
	if [ $? -eq 0 ];then
		VGNAME=$(lvdisplay  $ROOT_DEV |grep 'VG Name'|awk '{print  $NF}')		##  ===> nms
		DEVICE_NAME=$(pvdisplay --columns|grep $VGNAME |sed -n 1p|awk '{print $1}')	## ===>/dev/sda2

		DEVICE=$(echo $DEVICE_NAME | cut -b1-8)  # ===> /dev/sda
		DEV=$(echo $ROOT_DEV|cut -c 13-)	# ===> sda2
	else
		DEVICE=`echo $ROOT_DEV | cut -b1-8`   # ===> /dev/sda
		DEV=`echo $ROOT_DEV | cut -b6-10`     # ===> sda1
	fi

	titledev=" ($DEV)" 		      # ===> (sda1)
	#DEV_SDA1=""$DEVICE"1"

	NUM=`echo $ROOT_DEV | cut -b9-11 | wc -L`

    SDX_1="${DEVICE}1"	
    BOOT="/mnt/stage1"		      #===>we need mount /dev/sda1 on it(BOOT)
    boot_on_sdx1=`df |grep /mnt/sysimage/boot$|cut -d " " -f 1`

    BACKUP_DEV=$(df |grep /mnt/sysimage/srv$ | awk -F " " '{print $1}')
    ALL_DISK_INSTALL=0
    if [ -n "$BACKUP_DEV" -a "$BACKUP_DEV" = "${DEVICE}3" ];then
	echo "BACKUP_DEV is ok"
        ALL_DISK_INSTALL=1
    fi

    #add for btrfs post install
    #df |grep /mnt/sysimage$ |grep "btrfs" > /dev/null
    df -T |grep "btrfs" > /dev/null
    if [ $? -eq 0 ];then
        echo "btrfs install" >>/tmp/ws.log
            KERNEL_CMDLINE="rootflags=subvol=root rhgb quiet splash loglevel=0 resume=/dev/sda2"
    else
            KERNEL_CMDLINE="rhgb quiet splash loglevel=0 resume=/dev/sda2"
    fi
    #add end

    #add for lvm post install 
    #df |grep /mnt/sysimage$ |grep "/dev/mapper" > /dev/null
    #if [ $? -eq 0 ];then
    #    echo "lvm install" >> /tmp/ws.log
    #    DEV=`df |grep /mnt/sysimage$ | grep "/dev/mapper"|cut -d " " -f 1 |cut -c 13-`
    #    titledev=" ($DEV)"
    #fi
    #add end

    #add by 9.22
    vmlinux="vmlinux-3.10.0"
    vmlinuz="vmlinuz-3.10.0"
    initrd="initramfs-3.10.0.img"
    initrd_backup="initrd.gz"
    #add end

    #mount first partition
    mkdir -p $BOOT
    mount $SDX_1 $BOOT  # mount  /dev/sda1 /mnt/stage1
    mkdir -p $BOOT/boot/
    if [ ! -f $BOOT/boot/grub.efi ];then
	cp $CDROM/boot/grub.efi $BOOT/boot/
    fi
    if [ "X$ROOT_DEV" = "X$SDX_1" ];then  ##all disk install 
	echo "11"
	/bin/cp $CDROM/boot/${initrd_backup} $BOOT/boot/
    else
	/bin/cp  ${ROOT_DIR}/boot/${vmlinux} $BOOT/boot/${vmlinux}-${DEV}
	/bin/cp  ${ROOT_DIR}/boot/${vmlinuz} $BOOT/boot/${vmlinuz}-${DEV}
	/bin/cp  ${ROOT_DIR}/boot/${initrd} $BOOT/boot/${initrd}-${DEV}
	vmlinux="${vmlinux}-${DEV}"
	vmlinuz="${vmlinuz}-${DEV}"
	initrd="${initrd}-${DEV}"
    fi

	#delete the old(the same name) boot menu
	if [ -f $BOOT/boot/boot.conf ];then
        	cat $BOOT/boot/boot.conf | grep "$titledev" >/dev/null
       		if [ $? -eq 0 ];then
        		num1=`cat $BOOT/boot/boot.conf | grep -n "$titledev" |sed -n 1p| cut -d':' -f 1`
        		num2=`expr $num1 - 1`
        		num3=`expr $num1 + 4`
        		sed -i $num2','$num3'd' $BOOT/boot/boot.conf
        	fi
        	cat $BOOT/boot/boot.conf | grep "$titledev" >/dev/null
       		if [ $? -eq 0 ];then
        		num1=`cat $BOOT/boot/boot.conf | grep -n "$titledev" |sed -n 1p| cut -d':' -f 1`
        		num2=`expr $num1 - 1`
        		num3=`expr $num1 + 4`
        		sed -i $num2','$num3'd' $BOOT/boot/boot.conf
        	fi
	fi

	if [ -f $BOOT/boot/boot.cfg ];then
        	cat $BOOT/boot/boot.cfg | grep "$titledev" > /dev/null
        	if [ $? -eq 0 ];then
        		num1=`cat $BOOT/boot/boot.cfg | grep -n "$titledev" |sed -n 1p| cut -d':' -f 1`
        		num2=`expr $num1 - 1`
        		num3=`expr $num1 + 4`
        		sed -i $num2','$num3'd' $BOOT/boot/boot.cfg
		fi
        	cat $BOOT/boot/boot.cfg | grep "$titledev" > /dev/null
        	if [ $? -eq 0 ];then
        		num1=`cat $BOOT/boot/boot.cfg | grep -n "$titledev" |sed -n 1p| cut -d':' -f 1`
        		num2=`expr $num1 - 1`
        		num3=`expr $num1 + 4`
        		sed -i $num2','$num3'd' $BOOT/boot/boot.cfg
		fi
	fi

	if [ -f $BOOT/boot/grub.cfg ];then
        	cat $BOOT/boot/grub.cfg | grep "$titledev" > /dev/null
        	if [ $? -eq 0 ];then
        		num1=`cat $BOOT/boot/grub.cfg | grep -n "$titledev" |sed -n 1p|cut -d':' -f 1`
        		num2=`expr $num1 - 1`
        		num3=`expr $num1 + 5`
        		sed -i $num2','$num3'd' $BOOT/boot/grub.cfg
        	fi
        	cat $BOOT/boot/grub.cfg | grep "$titledev" > /dev/null
        	if [ $? -eq 0 ];then
        		num1=`cat $BOOT/boot/grub.cfg | grep -n "$titledev" |sed -n 1p|cut -d':' -f 1`
        		num2=`expr $num1 - 1`
        		num3=`expr $num1 + 5`
        		sed -i $num2','$num3'd' $BOOT/boot/grub.cfg
        	fi
	fi

	if [ -f $BOOT/EFI/BOOT/grub.cfg ];then
        	cat $BOOT/EFI/BOOT/grub.cfg | grep "$titledev" > /dev/null
        	if [ $? -eq 0 ];then
        		num1=`cat $BOOT/EFI/BOOT/grub.cfg | grep -n "$titledev" |sed -n 1p|cut -d':' -f 1`
        		num2=`expr $num1 - 1`
        		num3=`expr $num1 + 5`
        		sed -i $num2','$num3'd' $BOOT/EFI/BOOT/grub.cfg
        	fi
        	cat $BOOT/EFI/BOOT/grub.cfg | grep "$titledev" > /dev/null
        	if [ $? -eq 0 ];then
        		num1=`cat $BOOT/EFI/BOOT/grub.cfg | grep -n "$titledev" |sed -n 1p|cut -d':' -f 1`
        		num2=`expr $num1 - 1`
        		num3=`expr $num1 + 5`
        		sed -i $num2','$num3'd' $BOOT/EFI/BOOT/grub.cfg
        	fi
	fi

	#generate grub.cfg. boot.cfg. boot.conf
	#for all disk install ###########################################################################################################
	if [ $ALL_DISK_INSTALL -eq 1 ];then
		/bin/cp -r $ROOT_DIR/boot/efi/EFI $BOOT
	
if [ $OVERLAY -eq 0 ];then   ##not power down protection

                    echo "
set default=0
set timeout=15
set menu_color_normal=white/black
set menu_color_highlight=yellow/black

### BEGIN /etc/grub.d/10_linux ###

menuentry 'NeoKylin Military Server 5.0$titledev'{
        set root=(\${root})
        linux (\${root})/boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
        initrd (\${root})/boot/$initrd
        boot
}
menuentry 'System Backup and Restore'{
	set root=(\${root})
	linux (\${root})/boot/$vmlinuz root=$ROOT_UUID console=$BACK_CMDLINE
	initrd (\${root})/boot/$initrd_backup
	boot
}


" >$BOOT/EFI/BOOT/grub.cfg

			echo "
timeout 15
default 0
showmenu 1

title NeoKylin Military Server 5.0$titledev
	root   (hd0,0)
	kernel /boot/$vmlinuz  root=$ROOT_UUID $KERNEL_CMDLINE
	initrd /boot/$initrd
title System Backup and Restore
        kernel (hd0,0)/boot/$vmlinuz root=$ROOT_UUID console=$BACK_CMDLINE
        initrd /boot/$initrd_backup
" > $BOOT/boot/boot.conf
	
			echo "
timeout 15
default 0
showmenu 1

title NeoKylin Military Server 5.0$titledev
        kernel /dev/fs/ext2@wd0/boot/$vmlinuz
        initrd /dev/fs/ext2@wd0/boot/$initrd
        args root=$ROOT_UUID $KERNEL_CMDLINE
title System Backup and Restore
        kernel /dev/fs/ext2@wd0/boot/$vmlinuz
        initrd /dev/fs/ext2@wd0/boot/$initrd_backup
        args root=$ROOT_UUID console=$BACK_CMDLINE
" > $BOOT/boot/boot.cfg

                        echo "
set default=0
set timeout=15
set menu_color_normal=white/black
set menu_color_highlight=yellow/black

menuentry 'NeoKylin Military Server 5.0$titledev'{
set root=(\${root})
linux \${prefix}/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
initrd \${prefix}/$initrd
boot
}
menuentry 'System Backup and Restore'{
set root=(\${root})
linux \${prefix}/$vmlinuz root=$ROOT_UUID console=$BACK_CMDLINE
initrd \${prefix}/$initrd_backup
boot
}


" > $BOOT/boot/grub.cfg
else
##power down protection
sed -i -e "/overlay/d" $ROOT_DIR/etc/fstab


                    echo "
set default=0
set timeout=15
set menu_color_normal=white/black
set menu_color_highlight=yellow/black

### BEGIN /etc/grub.d/10_linux ###

menuentry 'NeoKylin Military Server 5.0$titledev $overlay_title'{
        set root=(\${root})
        linux (\${root})/boot/$vmlinuz root=$ROOT_UUID root_rw=$OVERLAY_DEV $KERNEL_CMDLINE
        initrd (\${root})/boot/$initrd
        boot
}
menuentry 'NeoKylin Military Server 5.0$titledev'{
        set root=(\${root})
        linux (\${root})/boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
        initrd (\${root})/boot/$initrd
        boot
}
menuentry 'System Backup and Restore'{
	set root=(\${root})
	linux (\${root})/boot/$vmlinuz root=$ROOT_UUID console=$BACK_CMDLINE
	initrd (\${root})/boot/$initrd_backup
	boot
}


" >$BOOT/EFI/BOOT/grub.cfg

			echo "
timeout 15
default 0
showmenu 1

title NeoKylin Military Server 5.0$titledev $overlay_title
	root   (hd0,0)
	kernel /boot/$vmlinuz root=$ROOT_UUID root_rw=$OVERLAY_DEV $KERNEL_CMDLINE
	initrd /boot/$initrd
title NeoKylin Military Server 5.0$titledev
	root   (hd0,0)
	kernel /boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
	initrd /boot/$initrd
title System Backup and Restore
        kernel (hd0,0)/boot/$vmlinuz root=$ROOT_UUID console=$BACK_CMDLINE
        initrd /boot/$initrd_backup
" > $BOOT/boot/boot.conf
	
			echo "
timeout 15
default 0
showmenu 1

title NeoKylin Military Server 5.0$titledev $overlay_title
        kernel /dev/fs/ext2@wd0/boot/$vmlinuz
        initrd /dev/fs/ext2@wd0/boot/$initrd
        args root=$ROOT_UUID root_rw=$OVERLAY_DEV $KERNEL_CMDLINE
title NeoKylin Military Server 5.0$titledev
        kernel /dev/fs/ext2@wd0/boot/$vmlinuz
        initrd /dev/fs/ext2@wd0/boot/$initrd
        args root=$ROOT_UUID $KERNEL_CMDLINE
title System Backup and Restore
        kernel /dev/fs/ext2@wd0/boot/$vmlinuz
        initrd /dev/fs/ext2@wd0/boot/$initrd_backup
        args root=$ROOT_UUID console=$BACK_CMDLINE
" > $BOOT/boot/boot.cfg

                        echo "
set default=0
set timeout=15
set menu_color_normal=white/black
set menu_color_highlight=yellow/black

menuentry 'NeoKylin Military Server 5.0$titledev $overlay_title'{
set root=(\${root})
linux \${prefix}/$vmlinuz root=$ROOT_UUID root_rw=$OVERLAY_DEV $KERNEL_CMDLINE
initrd \${prefix}/$initrd
boot
}
menuentry 'NeoKylin Military Server 5.0$titledev'{
set root=(\${root})
linux \${prefix}/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
initrd \${prefix}/$initrd
boot
}
menuentry 'System Backup and Restore'{
set root=(\${root})
linux \${prefix}/$vmlinuz root=$ROOT_UUID console=$BACK_CMDLINE
initrd \${prefix}/$initrd_backup
boot
}

" > $BOOT/boot/grub.cfg
fi
	
	#Not all disk install ###########################################################################################################
	else
	        if [ -f $BOOT/boot/boot.conf ];then
			sed -i "/showmenu 1/a\\\ntitle NeoKylin Military Server 5.0$titledev\n\troot   (hd0,0)\n\tkernel /boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE\n\tinitrd /boot/$initrd\n" $BOOT/boot/boot.conf
		else

		    if [ $OVERLAY -eq 0 ];then   ##not power down protection
			echo "
timeout 15
default 0
showmenu 1

title NeoKylin Military Server 5.0$titledev
    root   (hd0,0)
    kernel /boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
    initrd /boot/$initrd
" > $BOOT/boot/boot.conf
		    else #power down protection
			echo "
timeout 15
default 0
showmenu 1

title NeoKylin Military Server 5.0$titledev $overlay_title
    root   (hd0,0)
    kernel /boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE root_rw=$OVERLAY_DEV
    initrd /boot/$initrd
title NeoKylin Military Server 5.0$titledev
    root   (hd0,0)
    kernel /boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
    initrd /boot/$initrd
" > $BOOT/boot/boot.conf
		    fi
		fi


		if [ -f $BOOT/boot/boot.cfg ];then
            		sed -i "/showmenu 1/a\\\ntitle NeoKylin Military Server 5.0$titledev\n\tkernel /dev/fs/ext2@wd0/boot/$vmlinuz\n\tinitrd /dev/fs/ext2@wd0/boot/$initrd\n\targs root=$ROOT_UUID $KERNEL_CMDLINE\n"  $BOOT/boot/boot.cfg
        	else
		    if [ $OVERLAY -eq 0 ];then   ##not power down protection
            		echo "
timeout 15
default 0
showmenu 1

title NeoKylin Military Server 5.0$titledev
    kernel /dev/fs/ext2@wd0/boot/$vmlinuz
    initrd /dev/fs/ext2@wd0/boot/$initrd
    args root=$ROOT_UUID $KERNEL_CMDLINE
" > $BOOT/boot/boot.cfg
                    else #power down protection
            		echo "
timeout 15
default 0
showmenu 1

title NeoKylin Military Server 5.0$titledev $overlay_title
    kernel /dev/fs/ext2@wd0/boot/$vmlinuz
    initrd /dev/fs/ext2@wd0/boot/$initrd
    args root=$ROOT_UUID $KERNEL_CMDLINE root_rw=$OVERLAY_DEV
title NeoKylin Military Server 5.0$titledev
    kernel /dev/fs/ext2@wd0/boot/$vmlinuz
    initrd /dev/fs/ext2@wd0/boot/$initrd
    args root=$ROOT_UUID $KERNEL_CMDLINE
" > $BOOT/boot/boot.cfg

                    fi
        	fi

		if [ -f $BOOT/boot/grub.cfg ];then
	            sed -i "/set menu_color_highlight=yellow\/black/a\\\nmenuentry 'NeoKylin Military Server 5.0$titledev'{\nset root=(\${root})\nlinux \${prefix}/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE\ninitrd \${prefix}/$initrd\nboot\n}\n"  $BOOT/boot/grub.cfg
        	else
		    if [ $OVERLAY -eq 0 ];then   ##not power down protection
            	    echo "
set default=0
set timeout=15
set menu_color_normal=white/black
set menu_color_highlight=yellow/black

menuentry 'NeoKylin Military Server 5.0$titledev'{
set root=(\${root})
linux \${prefix}/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
initrd \${prefix}/$initrd
boot
}

" > $BOOT/boot/grub.cfg
                    else #power down protection
            	    echo "
set default=0
set timeout=15
set menu_color_normal=white/black
set menu_color_highlight=yellow/black

menuentry 'NeoKylin Military Server 5.0$titledev $overlay_title'{
set root=(\${root})
linux \${prefix}/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE root_rw=$OVERLAY_DEV
initrd \${prefix}/$initrd
boot
}
menuentry 'NeoKylin Military Server 5.0$titledev'{
set root=(\${root})
linux \${prefix}/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
initrd \${prefix}/$initrd
boot
}
" > $BOOT/boot/grub.cfg
                    fi
	    	fi

		if [ -f $BOOT/EFI/BOOT/grub.cfg ];then
		    sed -i "/BEGIN \/etc\/grub.d\/10_linux/a\\\nmenuentry 'NeoKylin Military Server 5.0$titledev'{\n\tset root=(\${root})\n\tlinux (\${root})/boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE\n\tinitrd (\${root})/boot/$initrd\n\tboot\n}\n" $BOOT/EFI/BOOT/grub.cfg 

		else
		    /bin/cp -r $ROOT_DIR/boot/efi/EFI $BOOT
		    if [ $OVERLAY -eq 0 ];then   ##not power down protection
		    echo "
set default=0
set timeout=15
set menu_color_normal=white/black
set menu_color_highlight=yellow/black

### BEGIN /etc/grub.d/10_linux ###

menuentry 'NeoKylin Military Server 5.0$titledev'{
	set root=(\${root})
	linux (\${root})/boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
	initrd (\${root})/boot/$initrd
	boot
}

" >$BOOT/EFI/BOOT/grub.cfg
                    else #power down protection
		    echo "
set default=0
set timeout=15
set menu_color_normal=white/black
set menu_color_highlight=yellow/black

### BEGIN /etc/grub.d/10_linux ###

menuentry 'NeoKylin Military Server 5.0$titledev $overlay_title'{
	set root=(\${root})
	linux (\${root})/boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE root_rw=$OVERLAY_DEV
	initrd (\${root})/boot/$initrd
	boot
}
menuentry 'NeoKylin Military Server 5.0$titledev'{
	set root=(\${root})
	linux (\${root})/boot/$vmlinuz root=$ROOT_UUID $KERNEL_CMDLINE
	initrd (\${root})/boot/$initrd
	boot
}

" >$BOOT/EFI/BOOT/grub.cfg



                    fi
		fi
	fi
	umount -l $BOOT
	sync
fi
